using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using System.Collections;

namespace ComboxCellTypeDatasource
{
    public partial class Form1 : Form
    {
        string connectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\\Program Files\\Microsoft Office\\OFFICE11\\SAMPLES\\Northwind.mdb";
        OleDbConnection conn;
        DataTable dt;
        OleDbDataAdapter da;
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            conn = new System.Data.OleDb.OleDbConnection(connectionString);
            string myStr = "SELECT CompanyName FROM Customers";
            da = new System.Data.OleDb.OleDbDataAdapter(myStr, conn);
            dt = new DataTable();
            da.Fill(dt);

            //****** 1)Programatically loop your DataSet get the items and creating a string array 
            //to set as the Items property of the combobox celltype **********

            FarPoint.Win.Spread.CellType.ComboBoxCellType combo = new FarPoint.Win.Spread.CellType.ComboBoxCellType();
            int count = dt.Rows.Count - 1;
            String[] cbstr = new String[count];
            DataView dv = new DataView(dt);
            ArrayList mylist = new ArrayList();
            for (int i = 0; i < dv.Count; i++)
            {
                mylist.Add(dv[i].Row["CompanyName"]);
            }
            combo.Items = (string[])mylist.ToArray(typeof(string));
            fpSpread1.Sheets[0].Columns[0].CellType = combo;

            // ********2) Use Single column MultiColumnComboBoxCellType to set DataSource directly *******************

            FarPoint.Win.Spread.CellType.MultiColumnComboBoxCellType mc = new FarPoint.Win.Spread.CellType.MultiColumnComboBoxCellType();
            mc.DataSourceList = dt;
            mc.ShowColumnHeaders = false;
            mc.ShowGridLines = false;
            mc.ListWidth =(int)fpSpread1.ActiveSheet.Columns[2].Width;
            fpSpread1.ActiveSheet.Columns[2].CellType = mc;

        }
    }
}
